#include "_stralloc.h"
#include "_error.h"
#include "_str.h"
#include "_ip4.h"
#include "bailout.h"
#include "getclass.h"
#include "cdb.h"

static void die_cdb(void)
{ xbailout(111,errno,"failed to read CDB",0,0,0); }

static void
getclass_finish(stralloc *x)
{
	uint32 dpos = cdb_datapos(&cdb);
	unsigned int len = cdb_datalen(&cdb);
	if (!stralloc_ready(x,len)) oom();
	x->len=len;
	if (-1==cdb_read(&cdb,x->s,x->len,dpos)) die_cdb();
}

void
getclass(stralloc *sa,const char *cip)
{
	char *ip;
	union { char *c; const char *cc; }  u;
	u.cc=cip;
	ip=u.c;
	switch(cdb_find(&cdb,ip,4)) {
		case -1: die_cdb();
		case 1: getclass_finish(sa); return;
	}
	switch(cdb_find(&cdb,ip,3)) {
		case -1: die_cdb();
		case 1: getclass_finish(sa); return;
	}
	switch(cdb_find(&cdb,ip,2)) {
		case -1: die_cdb();
		case 1: getclass_finish(sa); return;
	}
	switch(cdb_find(&cdb,ip,1)) {
		case -1: die_cdb();
		case 1: getclass_finish(sa); return;
	}
	switch(cdb_find(&cdb,ip,0)) {
		case -1: die_cdb();
		case 1: getclass_finish(sa); return;
	}
	if (!stralloc_copys(sa,"rest")) oom();
}
